#
# This file is a portion of the Red Hat Update Agent
# Copyright (c) 1999 Red Hat, Inc.
#
# $Id: config.py,v 1.20 1999/11/03 20:17:22 pbrown Exp $

import string, os

class Config:
    
    def __init__(self):
	self.dict = {}
	self.fileName = None


    def load(self):
	if self.fileName == None:
	    return
	baseName = string.split(self.fileName, "/")[-1:][0]
	baseName = string.split(baseName, ".")[0]
	try:
	    f = open("%s/.%s" % (os.environ['HOME'], baseName), "r")
	    self.fileName = "%s/.%s" % (os.environ['HOME'], baseName)
	except:
	    try:
		f = open(self.fileName, "r")
	    except:
		print "error opening %s for reading." % self.fileName
		return

	key = ""
	comment = ""
	value = ""
	for line in f.readlines():
	    if string.split(line) == []:
		continue
	    if line[0] == "#":
		continue
	    try:
		(key, value) = string.split(line, "=", 2)
	    except:
		continue

	    key = string.lstrip(key)
	    key = string.rstrip(key)
	    value = string.lstrip(value)
	    value = string.rstrip(value)

	    cf = 0
	    pos = string.find(key, "[comment]")
	    if pos != -1:
		key = key[:pos]
		cf = 1

	    if cf:
		comment = value
	    else:
		# possibly split value into a list
		values = string.split(value, ";")
		if len(values) == 1:
		    try:
			value = int(value)
		    except:
			pass
		    self.dict[key] = (comment, value)
		elif values[0] == "":
		    self.dict[key] = (comment, [])
		else:
		    self.dict[key] = (comment, values[:-1])
		comment = ""

	f.close()


    def save(self):
	if self.fileName == None:
	    return
	baseName = string.split(self.fileName, "/")[-1:][0]
	baseName = string.split(baseName, ".")[0]
	try:
	    f = open(self.fileName, "w")
	    os.chmod(self.fileName, 0600)
	except:
	    self.fileName = "%s/.%s" % (os.environ['HOME'], baseName)
	    try:
		f = open(self.fileName, "w")
		os.chmod(self.fileName, 0600)
	    except:
		print "error opening %s for writing." % self.fileName
		return

	f.write("# Automatically generated Red Hat Update Agent config file, do not edit.\n")
	f.write("# Format: 1.0\n")
	f.write("")
	for key in self.dict.keys():
	    val = self.dict[key]
	    f.write("%s[comment]=%s\n" % (key, val[0]))
	    if type(val[1]) == type([]):
		f.write("%s=" % key)
		if len(val[1]) > 0:
		    for l in val[1]:
			f.write("%s;" % l)
		else:
		    f.write(";")
		f.write("\n")
	    else:
		f.write("%s=%s\n" % (key, val[1]))
	    f.write("\n")

	f.close()
	    

    def readEntry(self, name):
	try:
	    val = self.dict[name]
	except:
	    val = (None, None)

	return val[1]


    def writeEntry(self, name, value):
	try:
	    val = self.dict[name]
	except:
	    val = (None, None)

	val = (val[0], value)
	self.dict[name] = val


class Up2dateConfig(Config) :

    def __init__(self):
	Config.__init__(self)

	self.fileName = "/etc/up2date.conf"
	self.dict['debug'] = ("Whether or not debugging is enabled", 0)
	self.dict['regName'] = ("Registration user name", "")
	self.dict['regKey'] = ("Registration key", "")
	self.dict['adminAddress'] = ("List of e-mail addresses for update agent to communicate with when run in batch mode", ["root@localhost"])
	self.dict['storageDir'] = ("Where to store packages and other data when they are retrieved", "/var/tmp")
	self.dict['pkgServer'] = ("Package server", "priority.redhat.com")
	self.dict['pkgProg'] = ("Full path to program on server", "/up2date/server.cgi")
	self.dict['pkgSkipList'] = ("A list of package names, optionally including wildcards, to skip", ["kernel*"])
	self.dict['fileSkipList'] = ("A list of file names, optionally including wildcards, to skip", [])
	self.dict['noReplaceConfig'] = ("When selected, no packages that would change configuration data are automatically installed", 1)
	self.dict['retrieveNew'] = ("Display all available packages", 0)
	self.dict['retrieveOnly'] = ("Retrieve packages only", 0)
	self.dict['keepAfterInstall'] = ("Keep packages on disk after installation", 1)
	self.dict['depTries'] = ("Number of times to attempt dependency resolution", 3)
	self.dict['versionOverride'] = ("Override the automatically determined system version", "")


	
