#
# This file is a portion of the up2date client
# Copyright (c) 1999 Red Hat, Inc.
#
# $Id: configdlg.py,v 1.15 1999/11/03 20:17:22 pbrown Exp $

from gtk import *
import os
import re

class ConfigDialog(GtkWindow) :    

    def __init__(self, cfg):
	self.cfg = cfg
	GtkWindow.__init__(self, type=WINDOW_DIALOG,
			   title="Configuration - Up2Date")
	self.set_border_width(5)
	self.connect("delete-event", self.quit)

	vbox = GtkVBox()
	vbox.set_spacing(10)
	self.add(vbox)

	notebook = GtkNotebook()
	vbox.pack_start(notebook)

	userVBox = GtkVBox()

	aFrame = GtkFrame("User information")
	aFrame.set_border_width(10)
	userVBox.pack_start(aFrame)

	aTable = GtkTable(homogeneous=FALSE)
	aTable.set_border_width(10)
	aFrame.add(aTable)
	

	# registration username
	aTable.attach(GtkLabel("User ID:"), 0, 1, 0, 1)
	self.regNameEntry = GtkEntry()
	aTable.attach(self.regNameEntry, 1, 2, 0, 1)

	# registration data
	aTable.attach(GtkLabel("Password:"), 0, 1, 1, 2)
	self.regKeyEntry = GtkEntry()
	aTable.attach(self.regKeyEntry, 1, 2, 1, 2)


	aFrame = GtkFrame("E-Mail Addresses")
	aFrame.set_border_width(10)
	userVBox.pack_start(aFrame)
	
	aTable = GtkTable(homogeneous = FALSE)
	aTable.set_border_width(10)
	aTable.set_row_spacings(10)
	aTable.set_col_spacings(10)
	aFrame.add(aTable)

	# email stuff
	aTable.attach(GtkLabel("Add new:"), 0, 1, 0, 1)
	emailEntry = GtkEntry()
	aTable.attach(emailEntry, 1, 2, 0, 1)
	
	addButton = GtkButton("Add")
	aTable.attach(addButton, 2, 3, 0, 1, yoptions=EXPAND)
	
	hsep = GtkHSeparator()
	aTable.attach(hsep, 0, 3, 1, 2)
	aTable.set_row_spacing(0, 10)

	aFrame = GtkFrame()
	self.emailList = GtkCList()
	aFrame.add(self.emailList)
	aTable.attach(aFrame, 0, 2, 2, 6)

	editButton = GtkButton("Edit")
	aTable.attach(editButton, 2, 3, 4, 5, yoptions=EXPAND)

	removeButton = GtkButton("Remove")
	aTable.attach(removeButton, 2, 3, 5, 6, yoptions=EXPAND)


	emailEntry.connect("activate", self.addButtonAction,
			   (emailEntry, self.emailList))
	addButton.connect("clicked", self.addButtonAction,
			  (emailEntry, self.emailList))
	editButton.connect("clicked", self.editButtonAction,
			   (emailEntry,self.emailList))
	removeButton.connect("clicked", self.removeButtonAction,
			     self.emailList)

	notebook.append_page(userVBox, GtkLabel("User"))

	######################################################################

	serverVBox = GtkVBox()
	aFrame = GtkFrame("Package Server")
	aFrame.set_border_width(10)
	serverVBox.pack_start(aFrame)

	aTable = GtkTable(homogeneous = FALSE)
	aTable.set_border_width(10)
	aTable.set_row_spacings(10)
	aTable.set_col_spacings(10)
	aFrame.add(aTable)

	# server stuff
	aTable.attach(GtkLabel("Server:"), 0, 1, 0, 1)
	self.serverEntry = GtkEntry()
	aTable.attach(self.serverEntry, 1, 2, 0, 1)

	aTable.attach(GtkLabel("Program:"), 0, 1, 1, 2)
	self.programEntry = GtkEntry()
	self.programEntry.set_sensitive(FALSE)
	aTable.attach(self.programEntry, 1, 2, 1, 2)

	###

	aTable = GtkTable(homogeneous = FALSE)
	aTable.set_border_width(10)
	serverVBox.pack_start(aTable)
	
	self.noReplaceConfig = GtkCheckButton("Do not replace config files")
	aTable.attach(self.noReplaceConfig, 0, 1, 0, 1)

	self.retrieveOnly = GtkCheckButton("Retrieve packages, but do not install")
	aTable.attach(self.retrieveOnly, 0, 1, 1, 2)

	self.retrieveNew = GtkCheckButton("Display all available packages")
	aTable.attach(self.retrieveNew, 1, 2, 0, 1)
	
	self.keepAfterInstall = GtkCheckButton("Keep packages after installation")
	aTable.attach(self.keepAfterInstall, 1, 2, 1, 2)

	hbox = GtkHBox()
	hbox.set_border_width(10)
	serverVBox.pack_start(hbox, expand=FALSE)

	self.depTries = GtkSpinButton()
	self.depTries.set_digits(0)

	adjust = GtkAdjustment(3, 1, 10, 1)
	self.depTries.set_adjustment(adjust)
	hbox.pack_start(self.depTries)

	hbox.pack_start(GtkLabel("Attempts to resolve dependencies"))

	hbox = GtkHBox()
	serverVBox.pack_start(hbox, expand=FALSE)

	hsep = GtkHSeparator()
	hbox.pack_start(hsep, padding=10)

	
	aTable = GtkTable(homogeneous = FALSE)
	aTable.set_border_width(10)
	serverVBox.pack_start(aTable)

	l = GtkLabel("Override version:")
	l.set_justify(JUSTIFY_RIGHT)
	aTable.attach(l, 0, 1, 0, 1)
	
	self.versionCombo = GtkCombo()
	aTable.attach(self.versionCombo, 1, 2, 0, 1)

	l = GtkLabel("Package storage directory:")
	l.set_justify(JUSTIFY_RIGHT)
	aTable.attach(l, 0, 1, 1, 2)
	self.storageDir = GtkEntry()
	aTable.attach(self.storageDir, 1, 2, 1, 2)

	notebook.append_page(serverVBox, GtkLabel("Retrieval"))

	######################################################################

	pkgVBox = GtkVBox()
	aFrame = GtkFrame("Skip Packages")
	aFrame.set_border_width(10)
	pkgVBox.pack_start(aFrame)


	aTable = GtkTable(homogeneous = FALSE)
	aTable.set_border_width(10)
	aTable.set_row_spacings(10)
	aTable.set_col_spacings(10)
	aFrame.add(aTable)

	# package stuff
	aTable.attach(GtkLabel("Add new:"), 0, 1, 0, 1)
	pkgEntry = GtkEntry()
	aTable.attach(pkgEntry, 1, 2, 0, 1)
	
	addButton = GtkButton("Add")
	aTable.attach(addButton, 2, 3, 0, 1, yoptions=EXPAND)

	hsep = GtkHSeparator()
	aTable.attach(hsep, 0, 3, 1, 2)
	aTable.set_row_spacing(0, 10)

	aFrame = GtkFrame()
	self.pkgList = GtkCList()
	aFrame.add(self.pkgList)
	aTable.attach(aFrame, 0, 2, 2, 6)

	editButton = GtkButton("Edit")
	aTable.attach(editButton, 2, 3, 4, 5, yoptions=EXPAND)

	removeButton = GtkButton("Remove")
	aTable.attach(removeButton, 2, 3, 5, 6, yoptions=EXPAND)


	pkgEntry.connect("activate", self.addButtonAction,
			   (pkgEntry, self.pkgList))
	addButton.connect("clicked", self.addButtonAction,
			  (pkgEntry, self.pkgList))
	editButton.connect("clicked", self.editButtonAction,
			   (pkgEntry,self.pkgList))
	removeButton.connect("clicked", self.removeButtonAction,
			     self.pkgList)

	###

	aFrame = GtkFrame("Skip Files")
	aFrame.set_border_width(10)
	pkgVBox.pack_start(aFrame)

	aTable = GtkTable(homogeneous = FALSE)
	aTable.set_border_width(10)
	aTable.set_row_spacings(10)
	aTable.set_col_spacings(10)
	aFrame.add(aTable)

	# file stuff
	aTable.attach(GtkLabel("Add new:"), 0, 1, 0, 1)
	fileEntry = GtkEntry()
	aTable.attach(fileEntry, 1, 2, 0, 1)
	
	addButton = GtkButton("Add")
	aTable.attach(addButton, 2, 3, 0, 1, yoptions=EXPAND)

	hsep = GtkHSeparator()
	aTable.attach(hsep, 0, 3, 1, 2)
	aTable.set_row_spacing(0, 10)

	aFrame = GtkFrame()
	self.fileList = GtkCList()
	aFrame.add(self.fileList)
	aTable.attach(aFrame, 0, 2, 2, 6)

	editButton = GtkButton("Edit")
	aTable.attach(editButton, 2, 3, 4, 5, yoptions=EXPAND)

	removeButton = GtkButton("Remove")
	aTable.attach(removeButton, 2, 3, 5, 6, yoptions=EXPAND)

	fileEntry.connect("activate", self.addButtonAction,
			   (fileEntry, self.fileList))
	addButton.connect("clicked", self.addButtonAction,
			  (fileEntry, self.fileList))
	editButton.connect("clicked", self.editButtonAction,
			   (fileEntry,self.fileList))
	removeButton.connect("clicked", self.removeButtonAction,
			     self.fileList)

	notebook.append_page(pkgVBox, GtkLabel("Exceptions"))


	##################################################################

	bbox = GtkHButtonBox()
	bbox.set_layout (BUTTONBOX_END)
	bbox.set_spacing(10)
	vbox.pack_start(bbox)

	okButton = GtkButton("OK")
	okButton.connect("clicked", self.savequit)
	#okButton.set_flags(CAN_DEFAULT)
	#okButton.grab_default()
	bbox.pack_start(okButton)

	cancelButton = GtkButton("Cancel")
	cancelButton.connect("clicked", self.hide)
	bbox.pack_start(cancelButton)

	self.initialize() # read values from config


    def savequit(self, *args):
	self.writeValues()
	self.hide()


    def quit(self, *args):
	self.hide()


    def addButtonAction(self, button, (entry, list)) :
	
	if entry.get_text() == "":
	    return
	if list == self.emailList:
	    self.emailCount = self.emailCount + 1
	    self.emailList.append((entry.get_text(),))
	if list == self.fileList:
	    self.fileCount = self.fileCount + 1
	    self.fileList.append((entry.get_text(),))
	if list == self.pkgList:
	    self.pkgCount = self.pkgCount + 1
	    self.pkgList.append((entry.get_text(),))

	entry.set_text("")


    def editButtonAction(self, button, (entry, list)) :
	sel = list.selection
	if len(sel) > 0:
	    text = list.get_text(sel[0], 0)
	    self.removeButtonAction(None, list)
	    entry.set_text(text)
	    entry.grab_focus()


    def removeButtonAction(self, button, list) :
	count = 0
	if list == self.emailList:
	    if self.emailCount > 0:
		self.emailCount = self.emailCount - 1
		count = self.emailCount
	if list == self.pkgList:
	    if self.pkgCount > 0:
		self.pkgCount = self.pkgCount - 1
		count = self.pkgCount
	if list == self.fileList:
	    if self.fileCount > 0:
		self.fileCount = self.fileCount - 1
		count = self.fileCount

	sel = list.selection
	if len(sel) > 0:
	    list.remove(sel[0])
	    row = sel[0]
	    if count > 0:
		if row == count:
		    list.select_row(row-1, 0)
		else:
		    list.select_row(row, 0)


    def initialize(self):
	# User
	self.regNameEntry.set_text(self.cfg.readEntry("regName"))
	self.regKeyEntry.set_text("%s" % self.cfg.readEntry("regKey"))
	emails = self.cfg.readEntry("adminAddress")
	self.emailCount = len(emails)
	if self.emailCount != 0:
	    for s in emails:
		self.emailList.append((s,))
	else:
	    self.emailList.append(["root@localhost"])

	# Server
	self.serverEntry.set_text(self.cfg.readEntry("pkgServer"))
	self.programEntry.set_text(self.cfg.readEntry("pkgProg"))
	self.versionCombo.set_popdown_strings(["Red Hat Linux 6.1",
					       "Red Hat Linux 6.0"])
	s = self.cfg.readEntry("versionOverride")
	s = re.sub("_", " ", s)
	self.versionCombo.entry.set_text(s)

	# Packages
	pkgs = self.cfg.readEntry("pkgSkipList")
	self.pkgCount = len(pkgs)
	if self.pkgCount != 0:
	    for s in pkgs:
		self.pkgList.append([s])

	files = self.cfg.readEntry("fileSkipList")
	self.fileCount = len(files)
	if self.fileCount != 0:
	    for s in files:
		self.fileList.append([s])

	self.noReplaceConfig.set_active(self.cfg.readEntry("noReplaceConfig"))
	self.retrieveOnly.set_active(self.cfg.readEntry("retrieveOnly"))
	self.retrieveNew.set_active(self.cfg.readEntry("retrieveNew"))
	self.keepAfterInstall.set_active(self.cfg.readEntry("keepAfterInstall"))
	self.depTries.set_value(self.cfg.readEntry("depTries"));
	self.storageDir.set_text(self.cfg.readEntry("storageDir"))


    def writeValues(self):
	# User
	self.cfg.writeEntry("regName", self.regNameEntry.get_text())
	self.cfg.writeEntry("regKey", self.regKeyEntry.get_text())

	emails = []
	for i in range(self.emailCount):
	    emails.append(self.emailList.get_text(i, 0))
	self.cfg.writeEntry("adminAddress", emails)

	# Server
	self.cfg.writeEntry("pkgServer", self.serverEntry.get_text())
	self.cfg.writeEntry("pkgProg", self.programEntry.get_text())

	s = self.versionCombo.entry.get_text()
	s = re.sub(" ", "_", s)
	self.cfg.writeEntry("versionOverride", s)

	# Packages
	pkgs = []
	for i in range(self.pkgCount):
	    pkgs.append(self.pkgList.get_text(i, 0))
	self.cfg.writeEntry("pkgSkipList", pkgs)

	files = []
	for i in range(self.fileCount):
	    files.append(self.fileList.get_text(i, 0))
	self.cfg.writeEntry("fileSkipList", files)

	self.cfg.writeEntry("noReplaceConfig", 
			    self.noReplaceConfig.get_active())
	self.cfg.writeEntry("retrieveOnly",
			    self.retrieveOnly.get_active())
	self.cfg.writeEntry("retrieveNew",
			    self.retrieveNew.get_active())
	self.cfg.writeEntry("keepAfterInstall",
			    self.keepAfterInstall.get_active())
	self.cfg.writeEntry("depTries",
			    self.depTries.get_value_as_int());

	self.cfg.writeEntry("storageDir", self.storageDir.get_text())

	self.cfg.save()
	
	
if __name__ == "__main__":
    import config
    cfg = config.Up2dateConfig()
    cfg.load()
    c = ConfigDialog(cfg)
    c.connect("hide", mainquit)
    c.show_all()
    mainloop()
